#include "prizm.h"
#include "CBP.h"
//--------------------------------------------------------------------------------------------- sys call
void* GetVRAMAddress() {	//	from Gravity Duck source ( by PierrotLL )
	__asm__(
	    "mov.l syscall_adress, r2\n"
	    "mov.l getVRAM, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress: .long 0x80020070\n"
	    "getVRAM: .long 0x01E6");
}
int Bfile_RenameEntry( const unsigned short *oldname , const unsigned short *newname ){
	__asm__(
	    "mov.l syscall_adress1, r2\n"
	    "mov.l RenameEnt, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress1: .long 0x80020070\n"
	    "RenameEnt: .long 0x1DB3");
}

void Cursor_SetPosition( int x, int y ){
	__asm__(
	    "mov.l syscall_adress2, r2\n"
	    "mov.l CsrSetPos, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress2: .long 0x80020070\n"
	    "CsrSetPos: .long 0x01F1");
}
int PutKey( unsigned int *key, int mode ){
	__asm__(
	    "mov.l syscall_adress3, r2\n"
	    "mov.l PutKeycode, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress3: .long 0x80020070\n"
	    "PutKeycode: .long 0x0EA9");
}
int OpCodeToStr( const short opcode, const char*result ){
	__asm__(
	    "mov.l syscall_adress4, r2\n"
	    "mov.l opcodetostr, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress4: .long 0x80020070\n"
	    "opcodetostr: .long 0x128F");
}
int Bfile_GetFileInfo( const unsigned short *filename, FILE_INFO *fileinfo ){
	__asm__(
	    "mov.l syscall_adress5, r2\n"
	    "mov.l GetFileInfo, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress5: .long 0x80020070\n"
	    "GetFileInfo: .long 0x1DA7");
}
unsigned int Cursor_GetSettings(unsigned int *settingsarray){
	__asm__(
	    "mov.l syscall_adress6, r2\n"
	    "mov.l GetSettings, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress6: .long 0x80020070\n"
	    "GetSettings: .long 0x01F5");
}

unsigned char ColorIndexDialog0( unsigned char initial_index ){
	__asm__(
	    "mov.l syscall_adress7, r2\n"
	    "mov.l colorIndexDialog0, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress7: .long 0x80020070\n"
	    "colorIndexDialog0: .long 0x1814");
}
void Bkey_Set_RepeatTime(int KeyRepeatFirstCount, int KeyRepeatNextCount){		// set cursor rep
	__asm__(
	    "mov.l syscall_adress8, r2\n"
	    "mov.l bkey_Set_RepeatTime, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress8: .long 0x80020070\n"
	    "bkey_Set_RepeatTime: .long 0x12A4");
}
void Bkey_Get_RepeatTime( int *FirstCount, int *NextCount){	// repeat time
	__asm__(
	    "mov.l syscall_adress9, r2\n"
	    "mov.l bkey_Get_RepeatTime, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress9: .long 0x80020070\n"
	    "bkey_Get_RepeatTime: .long 0x12A5");
}
void Keyboard_ClrBuffer(){	//
	__asm__(
	    "mov.l syscall_adressA, r2\n"
	    "mov.l keyboard_ClrBuffer, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adressA: .long 0x80020070\n"
	    "keyboard_ClrBuffer: .long 0x12c7");
}
		
int Calljmp( int r4, int r5, int r6, int r7, int adrs ){
	__asm__(
		"mov.l	@r15,r1\n"
		"jmp	@r1\n"
		"nop");
}
int SysCalljmp( int r4, int r5, int r6, int r7, int No){
	__asm__(
		"mov.l	syscall_adressJ,r1\n"
		"mov.l	@r15,r0\n"
		"jmp	@r1\n"
		"nop\n"
		"nop\n"
	    "syscall_adressJ: .long 0x80020070");
}

//--------------------------------------------------------------------------------------------- std
unsigned int lastrandom=0x12345678;
unsigned int random( int seed ) {
    if (seed) lastrandom=seed;
    lastrandom = ( 0x41C64E6D*lastrandom ) + 0x3039;
    return ( lastrandom >> 16 );
}

//int rand() {
//	return random(0);
//}
//int srand( int seed ) {
//	return random(seed);
//}

//--------------------------------------------------------------------------------------------- std

int strncmp(const char* s1, const char* s2, size_t n)
{
    while(n--)
        if(*s1++!=*s2++)
            return *(unsigned char*)(s1 - 1) - *(unsigned char*)(s2 - 1);
    return 0;
}

void * memcpy2(void *dest, const void *src, size_t len)
{
	char *d = dest+len-1;
	const char *s = src+len-1;
	while (len--)
    	*d-- = *s--;
  	return dest;
}

//--------------------------------------------------------------------------------------------- math

double fabs(double x){
	if ( x < 0 ) return -x; else return x;
}

double floor( double x ) {
	double result;
	unsigned char *row;
	int tmp,exp;
	int i,j,bt;
	unsigned char *ptr;

	if ( fabs(x)<1 ) return 0;

	ptr=(unsigned char *)(&x);
	row=(unsigned char *)(&result);
	result=x;

	tmp= ( (row[0]&0x7f)<<4 ) + ( (row[1]&0xf0)>>4 ) ;
	exp=tmp-1023; // 
	if ( ( 0 <= exp ) && ( exp <= 51 ) ) {
		tmp=52-exp;
		i=7; j=0; bt=0xFE;
		while ( tmp ) {
			if (tmp>7) {
				 tmp-=8; row[i]=0; i--;
			} else {
				row[i]&=bt;
				bt=bt<<1;
				j++;
				tmp--;
			}
		}
	}
	return ( result ); 
}

double atof( char* buf ) {
	int expbuf=ExecPtr;
	ExecPtr=0;
	double r=Eval_atof( buf, *buf);
	ExecPtr=expbuf;
	return r;
}
double fmod(double x,double y){
	if ( y==0 ) return 0;
	return x-floor(x/y)*y;
}


double acos(double x){
	return x;
}
double asin(double x){
	return x;
}
double atan(double x){
	return x;
}
double atan2(double x,double y){
	return x;
}
double cos(double x){
	return icos( (int)(x*180./const_PI+.5), 1024 )/1024.;
}
double sin(double x){
	return isin( (int)(x*180./const_PI+.5), 1024 )/1024.;
}
double tan(double x){
	double c=icos( (int)(x*180./const_PI+.5), 1024 );
	if ( c ) return isin( (int)(x*180./const_PI+.5), 1024 )/c;
	return 0;
}
double cosh(double x){
	return x;
}
double tanh(double x){
	return x;
}
double sinh(double x){
	return x;
}
double exp(double x){
	return x;
}
double log(double x){
	double t2;
	int i,j,k;
	if ( x>=1 ) {
		i=1;
		while ( x>1.00001 ) {
			x=sqrt(x);
			i++; if ( i>64 ) break;
		}
	} else {
		i=1;
		while ( x<0.9999 ) {
			x=sqrt(x);
			i++; if ( i>64 ) break;
		}
	}
	x=(x-1.0)/(x+1.0);
	x=x+x*x*x/3;
	t2=pow(2,i);
	return x*t2;
}
double log10(double x){
	return log(x)/log(10);
}
double pow(double x,double y){
	int i;
	double r=x;
	if ( y>=0 ) {
		for ( i=1; i<(int)y; i++ ) r*=x;
	} else {
		r=1;
		for ( i=0; i<(int)(fabs(y)); i++ ) r/=x;
	}
	return r;
}
double sqrt(double x){
	double a=x,b=x;
	int i=0;
	if ( x==0 ) return 0;
	while (i++<32){
		b=(b+x/b)/2;
		if ( fabs(a-b)<.5e-15 ) break;
		a=b;
	}
	return b;
}

//--------------------------------------------------------------------------------------------- Bfile
int Bfile_OpenFile(const FONTCHARACTER *filename, int mode){
	return Bfile_OpenFile_OS( filename, mode, -1);
}
int Bfile_DeleteFile(const FONTCHARACTER *filename){
	return Bfile_DeleteEntry( filename);
}
int Bfile_DeleteDirectory(const FONTCHARACTER *pathname){
	return Bfile_DeleteEntry( pathname);
}
int Bfile_CreateFile(const FONTCHARACTER *filename, int size){
	return Bfile_CreateEntry_OS(  filename, 1, &size  );	// file
}
int Bfile_CreateDirectory(const FONTCHARACTER *pathname){
	int size;
	return Bfile_CreateEntry_OS(  pathname, 5, &size  );	// Directory
}
int Bfile_GetMediaFree(enum DEVICE_TYPE devicetype, int *freebytes){
	if  ( devicetype == DEVICE_SD_CARD ) return -1;
	freebytes[0]=12345;
	return 0;
}
int Bfile_GetFileSize(int HANDLE){
	return Bfile_GetFileSize_OS( HANDLE, 0 );
}
//--------------------------------------------------------------------------------------------- Bdisp
void SaveDisp( int n ){
//	SaveVRAM_1();
	unsigned short *buf=BufVRAM,*vram=GetVRAMAddress()+24*384*2;
	int i;
	for (i=24*384; i<216*384; i++ ) *buf++=*vram++;
}

void RestoreDisp(int n){
//	LoadVRAM_1();
	unsigned short *buf=BufVRAM,*vram=GetVRAMAddress()+24*384*2;
	int i;
	for (i=24*384; i<216*384; i++ ) *vram++=*buf++;
}

void Bdisp_AllClr_VRAM2(){
	unsigned short *vram=GetVRAMAddress()+24*384*2;
	unsigned short backcolor=CB_BackColorIndex;
	int i;
	for (i=24*384; i<216*384; i++ ) *vram++=backcolor;
}

void Bdisp_AllClr_DDVRAM(){
	Bdisp_AllClr_VRAM();
	Bdisp_PutDisp_DD();
}

void Bdisp_AreaReverseVRAM( int x1, int y1, int x2, int y2 ) {
	int x,y;
	unsigned short *vram=GetVRAMAddress();
	for ( y=y1; y<=y2; y++) {
		for ( x=x1; x<=x2; x++) {
			vram[x+y*384]^=0xFFFF ;
		}
	}
}
void Bdisp_AreaClr_VRAM( int x1, int y1, int x2, int y2 ) {
	int x,y;
	unsigned short *vram=GetVRAMAddress();
	unsigned short color,backcolor=CB_BackColorIndex;
	for ( y=y1; y<=y2; y++) {
		for ( x=x1; x<=x2; x++) {
			vram[x+y*384]=backcolor;
		}
	}
}

void Bdisp_AreaReverseVRAMx3( int x1, int y1, int x2, int y2 ) {
	Bdisp_AreaReverseVRAM( x1*3, y1*3+24, x2*3+2, y2*3+2+24 );
}
void Bdisp_SetPoint_DDVRAM(int x, int y, unsigned char point){
}
void Bdisp_GetDisp_VRAM(unsigned char *pData){
}
void Bdisp_WriteGraph_DD(const DISPGRAPH *WriteGraph){
}

void Bdisp_WriteGraph_VRAM_CG(const DISPGRAPH *WriteGraph){	// CG mode
	unsigned char *vram=GetVRAMAddress();
	unsigned short *vram2=GetVRAMAddress();
	int ptr1,ptr2;
	int i,j,x,y,c;	
	int px = WriteGraph->x ; 
	int py = WriteGraph->y ; 
	int dx = WriteGraph->GraphData.width ;
	int dy = WriteGraph->GraphData.height ;
	unsigned char *Gptr = WriteGraph->GraphData.pBitmap ;
	int Modify = WriteGraph->WriteModify; 
	int Kind =   WriteGraph->WriteKind;
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;

	for ( y=py; y<py+dy; y++ ) {	// CG mode
			ptr1=(y-py)*384*2; ptr2=px+(y+24)*384*2;
			for ( x=0; x<dx; x++ ) {
				vram[ptr2++]=Gptr[ptr1++];
				vram[ptr2++]=Gptr[ptr1++];
			}
	}
}
void Bdisp_WriteGraph_RAM_fx_xy1(const DISPGRAPH *WriteGraph, unsigned char* ram, int factor ){	// fx {384,192} mode
	unsigned char *vram=ram;
	unsigned short *vram2=ram;
	int ptr1,ptr2;
	int i,j,x,y,c;	
	int px = WriteGraph->x *factor ; 
	int py = WriteGraph->y *factor ; 
	int dx = WriteGraph->GraphData.width ;
	int dy = WriteGraph->GraphData.height ;
	unsigned char *Gptr = WriteGraph->GraphData.pBitmap ;
	int Modify = WriteGraph->WriteModify; 
	int Kind =   WriteGraph->WriteKind;
	int dimA,dimB,SizeA;
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;
	dimA=(px+dx)/8;
	dimB=dy;
	SizeA=dx;
//			return ( MatAryC[ dimB*(((SizeA-1)>>3)+1)+(dimA>>3) ] & ( 128>>(dimA&7) ) ) != 0 ;
//			return ( MatAryC[ dimB*(((SizeA-1)>>3)+1)+(dimA>>3) ] & (128>>(dimA&7))  ) != 0 ;
//			return ( MatAryC[ y*(((dx-1)>>3)+1)+(x>>3) ] & (128>>(x&7))  ) != 0 ;
	for ( y=0; y<dy; y++ ) {
		for ( x=0; x<dx; x++ ) {
			i=Gptr[ y*(((dx-1)>>3)+1)+(x>>3) ] & (128>>(x&7));
			switch ( Modify ) {
				case IMB_WRITEMODIFY_NORMAL:
					if ( i ) c=color; else c=backcolor;
					break;
				case IMB_WRITEMODIFY_REVERCE:
					if ( i ) c=backcolor; else c=color;
					break;
				case IMB_WRITEMODIFY_MESH:
					if ( i ) c=color; else c=backcolor;
					if ( (x+px)&1 ^ (y+py)&1 ) c=backcolor;
					break;
			}
			i=(y*3+py) +24; j=x*3+px;
			if ( (j<382) && (i<214) ) {
				ptr1=j+i*384;
				switch ( Kind ) {
					case IMB_WRITEKIND_OR:
						if ( c==backcolor ) break;
					case IMB_WRITEKIND_OVER:
					  pset:
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						ptr1+=381;
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						ptr1+=381;
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						vram2[ptr1++]=c;
						break;
					case IMB_WRITEKIND_AND:
						if ( vram2[ptr1] == backcolor ) break;
						goto pset;
						break;
					case IMB_WRITEKIND_XOR:
						if ( ( c==color ) && ( vram2[ptr1] != backcolor ) ) c=backcolor; else c=color;
						goto pset;
						break;
				}
			}
		}
	}

}
void Bdisp_WriteGraph_RAM_fx( const DISPGRAPH *WriteGraph, unsigned char* ram  ){	// fx {128,64} mode
	Bdisp_WriteGraph_RAM_fx_xy1( WriteGraph, ram, 3 );
}
void Bdisp_WriteGraph_VRAM_fx( const DISPGRAPH *WriteGraph){	// fx {128,64} VRAM
	Bdisp_WriteGraph_RAM_fx_xy1( WriteGraph, GetVRAMAddress(), 3 );
}
void Bdisp_WriteGraph_VRAM_fx_xy1(const DISPGRAPH *WriteGraph){	// fx {384,192} VRAM
	Bdisp_WriteGraph_RAM_fx_xy1( WriteGraph, GetVRAMAddress(), 1 );
}

void Bdisp_WriteGraph_VRAM(const DISPGRAPH *WriteGraph){	//
	if ( CB_G1MorG3M == 1 )	Bdisp_WriteGraph_VRAM_fx(WriteGraph);
	else					Bdisp_WriteGraph_VRAM_CG(WriteGraph);
}

void Bdisp_ReadArea_VRAM_CG(const DISPBOX *ReadArea, unsigned char *ReadData){	// CG
	unsigned char *vram=GetVRAMAddress();
	unsigned short *vram2=GetVRAMAddress();
	int ptr1,ptr2;
	int i,j,x,y,c;	
	int x1=ReadArea->left; 
	int y1=ReadArea->top; 
	int x2=ReadArea->right;
	int y2=ReadArea->bottom;
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;

	for ( y=y1; y<=y2; y++ ) {	// CG mode
			ptr1=(y-y1)*384*2; ptr2=x1+(y+24)*384*2;
			for ( x=x1; x<=x2; x++ ) {
				ReadData[ptr1++]=vram[ptr2++];
				ReadData[ptr1++]=vram[ptr2++];
			}
	}
}
void Bdisp_ReadArea_RAM_fx(const DISPBOX *ReadArea, unsigned char *ReadData, unsigned char* ram ){	// fx mem mode
	unsigned char *vram=ram;
	unsigned short *vram2=ram;
	int ptr1,ptr2;
	int i,j,x,y,c;	
	int x1=ReadArea->left; 
	int y1=ReadArea->top; 
	int x2=ReadArea->right;
	int y2=ReadArea->bottom;
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;

	for ( i=y1; i<=y2; i++ ) {	// fx mode
		for ( j=x1; j<=x2; j++ ) {
			x=j-x1; y=i-y1;
			if ( vram2[j*3+1+(i*3+25)*384] != backcolor ) {
				ReadData[(y<<4)+(x>>3)] |= 128>>(x&7);		// 1
			} else {
				ReadData[(y<<4)+(x>>3)] &= ~(128>>(x&7));	// 0
			}
		}
	}
}

void Bdisp_ReadArea_VRAM_fx(const DISPBOX *ReadArea, unsigned char *ReadData){	// fx
	Bdisp_ReadArea_RAM_fx( ReadArea, ReadData, GetVRAMAddress() );
}

void Bdisp_ReadArea_VRAM(const DISPBOX *ReadArea, unsigned char *ReadData){	// CG or fx
	if ( CB_G1MorG3M == 1 ) 
		Bdisp_ReadArea_VRAM_fx( ReadArea, ReadData );
	else
		Bdisp_ReadArea_VRAM_CG( ReadArea, ReadData );
}



void Bdisp_DrawLineVRAM( int x1, int y1, int x2, int y2 ) {
	LinesubFX(x1, y1, x2, y2, S_L_Normal, 1);
}
void Bdisp_ClearLineVRAM( int x1, int y1, int x2, int y2 ) {
	LinesubFX(x1, y1, x2, y2, S_L_Normal, 0);
}

void DD_SetContrast( int n ) {
}

void Print( char*msg ){
	Print_OS( (unsigned char*)msg, 0, 0 );
}

void PrintRev( char*msg ){
	Print_OS( (unsigned char*)msg, 1, 0 );
}

void PrintMiniXY(int X, int Y, char*buf, int COLOR,int BackCOLOR) {
	PrintMini(&X, &Y, (unsigned char*)buf, 0, 0xFFFFFFFF, 0, 0, COLOR, BackCOLOR, 1, 0);
}
/*
void PrintC( unsigned char *str ){
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	Print_OS( str, 0, 0 );
	str[k]=b;
	return i;
}
void PrintRevC( unsigned char *str ){
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	Print_OS( (unsigned char*)str, 1, 0 );
	str[k]=b;
	return i;
}
*/
int PrintMinix1( int X, int Y, unsigned char*buf, int mode, unsigned short  color, unsigned short  backcolor ) {
	int x0=X;
	switch ( mode ) {
		case MINI_OVER:
			PrintMini(&X, &Y, (unsigned char*)buf, 0, 0xFFFFFFFF, 0, 0, color, backcolor, 1, 0);
			break;
		case MINI_OR:
			PrintMini(&X, &Y, (unsigned char*)buf, 2, 0xFFFFFFFF, 0, 0, color, backcolor, 1, 0);
			break;
		case MINI_REV:
			PrintMini(&X, &Y, (unsigned char*)buf, 0, 0xFFFFFFFF, 0, 0, backcolor, color, 1, 0);
			break;
		case MINI_REVOR:
			PrintMini(&X, &Y, (unsigned char*)buf, 2, 0xFFFFFFFF, 0, 0, ~color, ~backcolor, 1, 0);
			break;
	}
	return (X-x0);
}

int PrintMinix3( int X, int Y, unsigned char*buf, int mode ) {
	unsigned short color=0x0000;	// black
	unsigned short backcolor=0xFFFF;	// white
	X*=3;
	Y*=3;
	return PrintMinix1( X, Y, buf, mode, color, backcolor ) /3;
}

int GetColorIndex( void ) {
	int color;
	int	i=ColorIndexDialog0( 0 );
	switch ( i ) {
		case 0:	// black
			color=0x0000;	// Black
			break;
		case 1:	// blue
			color=0x001F;	// Blue
			break;
		case 2:	// green
			color=0x07E0;	// Green
			break;
		case 3:	// cyan
			color=0x07FF;	// Cyan
			break;
		case 4:	// red
			color=0xF800;	// Red
			break;
		case 5:	// magenda
			color=0xF81F;	// Magenta
			break;
		case 6:	// yellow
			color=0xFFE0;	// Yellow
			break;
//		case 7:	// white
//			key=0x0000;	
//			break;
		default:
			color=0x0000;	// Black
			break;
	}
	return color;
}
int GetColor2Index( int colorRGB ) {
	int color;
	switch ( colorRGB ) {
		case 0:	// black
			color=0x0000;	// Black
			break;
		case 0x001F:	// blue
			color=1;	// Blue
			break;
		case 0x07E0:	// green
			color=2;	// Green
			break;
		case 0x07FF:	// cyan
			color=3;	// Cyan
			break;
		case 0xF800:	// red
			color=4;	// Red
			break;
		case 0xF81F:	// magenda
			color=5;	// Magenta
			break;
		case 0xFFE0:	// yellow
			color=6;	// Yellow
			break;
		case 0xFFFF:	// white
			color=7;	// white
			break;
		default:
			color=8;	// color
			break;
	}
	return color;
}

void CB_ScrollBar(int max, int pos ) {
	TScrollbar scrollbar;
	scrollbar.I1=0;
	scrollbar.indicatormaximum= max;
	scrollbar.indicatorheight=0;
	scrollbar.indicatorpos= pos;
	scrollbar.I5=0;
	scrollbar.barleft=   384-6;
	scrollbar.bartop=    0;
	scrollbar.barheight= 168;
	scrollbar.barwidth=  6;
	
	Scrollbar( &scrollbar );
}


//---------------------------------------------------------------------------------------------
void SetStatusMessage( char*msg, char short_color ){
	DefineStatusMessage( msg, 1, short_color, 7 );
	DisplayStatusArea();
}
//
void StatusArea( char*msg, char short_color ){
//	Bdisp_AllClr_VRAM();
	SetStatusMessage( msg, short_color );
}

void StatusArea_sub(){
    EnableStatusArea(0);
    DefineStatusAreaFlags(DSA_SETDEFAULT, 0, 0, 0);
    DefineStatusAreaFlags(3, SAF_BATTERY | SAF_TEXT | SAF_GLYPH | SAF_ALPHA_SHIFT, 0, 0);
	StatusArea( VerMSG,TEXT_COLOR_BLUE);
}
void StatusArea_Edit( char *name, int num ){
	char buf[64];
    EnableStatusArea(0);
    DefineStatusAreaFlags(DSA_SETDEFAULT, 0, 0, 0);
    DefineStatusAreaFlags(3, SAF_BATTERY | SAF_TEXT | SAF_GLYPH | SAF_ALPHA_SHIFT , 0, 0);
    sprintf(buf,"%s  free:%d", name, num);
	StatusArea( buf,TEXT_COLOR_BLUE);
}
void StatusArea_Run_sub( char *str ){
	char buf[64];
    const char *angle[]  ={"[Deg]","[Rad]","[Gra]"};
    EnableStatusArea(0);
    DefineStatusAreaFlags(DSA_SETDEFAULT, 0, 0, 0);
    DefineStatusAreaFlags(3, SAF_BATTERY | SAF_TEXT | SAF_GLYPH | SAF_ALPHA_SHIFT , 0, 0);
	sprintf(buf, "%s%s%d%s%s  %-8s", angle[Angle], CB_INTDefault ? "[INT%" : "[DBL#", MatBaseDefault, "]", CB_G1MorG3M==1 ? "[g1m]" : "[g3m]", str);
	StatusArea( buf,TEXT_COLOR_BLUE);
}
void StatusArea_Run(){
	char buf2[32];
	strncpy(buf2,(const char*)ProgfileAdrs[ProgNo]+0x3C,8);
	buf2[8]='\0';
	StatusArea_Run_sub( buf2 );
}


//---------------------------------------------------------------------------------------------

void Cursor_SetFlashMode(int mode){ 			// cursor 
	Cursor_SetFlashOn( mode );
}
int Cursor_GetFlashStyle(){
	unsigned int settingsarray[5];
	Cursor_GetSettings( settingsarray);
	return settingsarray[2];	// flashstyle
}


//--------------------------------------------------------------------------------------------- Timer
int SetTimer(int ID, int elapse, void (*handler)(void)){
	int id;
	id=Timer_Install( ID,  handler, elapse ); 
	Timer_Start( id );
	return id;
}

int KillTimer(int ID){
	Timer_Stop( ID );
	Timer_Deinstall( ID );
}

//--------------------------------------------------------------------------------------------- Serial

int Serial_GetFreeTransmitSpace(){
} 
int Serial_BufferedTransmitOneByte( int c ){
}
int Serial_ReadOneByte( char c ){
}
int Serial_GetReceivedBytesAvailable(){
}
void Serial_ClearTransmitBuffer(){
}

//---------------------------------------------------------------------------------------------
// the function assumes, that the RAM-pointer to GetkeyToMainFunctionReturnFlag is loaded 
// immediately by a "Move Immediate Data"-instruction
unsigned int SetGetkeyToMainFunctionReturnFlag( unsigned int enabled ){
int addr, addr2;
// get the pointer to the syscall table
	addr = *(unsigned char*)0x80020071;	// get displacement
	addr++;
	addr *= 4;
	addr += 0x80020070;
	addr = *(unsigned int*)addr;
	if ( addr < 0x80020070 ) return 0x101;
	if ( addr >= 0x81000000 ) return 0x102;
// get the pointer to syscall 1E99
	addr += 0x1E99*4;
	if ( addr < 0x80020070 ) return 0x103;
	if ( addr >= 0x81000000 ) return 0x104;

	addr = *(unsigned int*)addr;
	if ( addr < 0x80020070 ) return 0x105;
	if ( addr >= 0x81000000 ) return 0x106;

	switch ( *(unsigned char*)addr ){
		case 0xD0 : // MOV.L @( disp, PC), Rn (REJ09B0317-0400 Rev. 4.00 May 15, 2006 page 216)
		case 0xD1 :
		case 0xD2 :
		case 0xD3 :
		case 0xD4 :
		case 0xD5 :
		case 0xD6 :
		case 0xD7 :
		case 0xD8 :
			addr2 = *(unsigned char*)( addr + 1 );	// get displacement
			addr2++;
			addr2 *= 4;
			addr2 += addr;
			addr2 &= ~3;

			if ( addr2 < 0x80020070 ) return 0x107;
			if ( addr2 >= 0x81000000 ) return 0x108;

			addr = *(unsigned int*)addr2;
			if ( ( addr & 0xF8000000 ) != 0x88000000 ) return 0x109;

// finally perform the desired operation and set the flag:
			if ( enabled ) *(unsigned char*)addr = 0;
			else *(unsigned char*)addr = 3;

			break;

		default : addr = 0x100;
	}
	return addr;
}
